=== debian/changelog ===
opencv (4.6.0+dfsg-12revyos1) unstable; urgency=medium

  * Disable WITH_OPENGL

 -- Han Gao <gaohan@iscas.ac.cn>  Thu, 22 Jun 2023 03:08:34 +0800

opencv (4.6.0+dfsg-12) unstable; urgency=medium

  * Team upload.

  [ Andreas Beckmann ]
  * libopencv-core406: Add Breaks: libopencv-core4.5 for smoother upgrades from bullseye
    (Closes: #1035886)

  [ Jochen Sprickerhof ]
  * Add upstream patches for CVE-2023-2617 and CVE-2023-2618 (Closes: #1035954)

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 12 May 2023 11:40:38 +0200

opencv (4.6.0+dfsg-11) unstable; urgency=medium

  * Update d/rules.
    Use -DCMAKE_SKIP_RPATH=ON instead of -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON.
    (Closes: #1024638)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Wed, 01 Mar 2023 10:21:45 +0900

opencv (4.6.0+dfsg-10) unstable; urgency=medium

  * Update d/rules.
    Add -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON to configure of python extension
    (Closes: #1024638)

 -- Nobuhiro Iwamatsu <iwamatsu@debian.org>  Mon, 16 Jan 2023 11:23:50 +0900

opencv (4.6.0+dfsg-9) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS on arch any (Closes: #1024507)

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 20 Nov 2022 22:22:15 +0100

opencv (4.6.0+dfsg-8) unstable; urgency=medium

  * Team upload.

  [ Victor Westerhuis ]
  * Build Python extension for all supported versions (Closes: 972566)
  * Make binaries build reproducibly
  * Make documentation build reproducibly (Closes: #1024482)

  [ Jochen Sprickerhof ]
  * Update build dependency

 -- Jochen Sprickerhof <jspricke@debian.org>  Sun, 20 Nov 2022 16:12:59 +0100

opencv (4.6.0+dfsg-7) unstable; urgency=medium

  [ Victor Westerhuis ]
  * Do not try to download any files while building (Closes: 1019519)
  * Support building by directly calling d/rules
  * Fix Java architecture test in d/build
  * Do not build unused statically linked apps and Java bindings
  * Delete useless Build-Depends on libswresample
  * Fix building with LAPACK
  * Build highgui module with QT support (Closes: 958028)

  [ Mo Zhou ]
  * Fix broken symlink for .jar file. (Closes: #1019863)

 -- Mo Zhou <lumin@debian.org>  Wed, 21 Sep 2022 20:51:42 -0400

opencv (4.6.0+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Revert "Package ovis module"
    Needs libogre-1.12-dev which is not available on mipsel

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 09 Aug 2022 09:38:18 +0200

opencv (4.6.0+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Add patches to fix build (Closes: #1016684)
  * Package ovis module

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 09 Aug 2022 07:02:57 +0200

opencv (4.6.0+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 01 Jul 2022 22:22:48 +0200

opencv (4.6.0+dfsg-3) experimental; urgency=medium

  * Team upload.
  * Don't build static Python 3 module

 -- Jochen Sprickerhof <jspricke@debian.org>  Thu, 30 Jun 2022 13:13:22 +0200

opencv (4.6.0+dfsg-2) experimental; urgency=medium

  [ Adrian Bunk ]
  * Team upload.
  * Link with libatomic on architectures that might need it

  [ Jochen Sprickerhof ]
  * Clean up old Breaks/Conflicts/Replaces
  * Drop versioned dependency (in oldoldstable)

 -- Jochen Sprickerhof <jspricke@debian.org>  Tue, 28 Jun 2022 07:39:59 +0200

opencv (4.6.0+dfsg-1) experimental; urgency=medium

  * Team upload.
  * Update d/copyright
  * Use oversionmangle in d/watch
  * Add d/gbp.conf to import component as well
  * New upstream version 4.6.0+dfsg (Closes: #1004718)
  * Drop patch for debian-specific SOVERSION
  * Drop salsa-ci.yml
  * Rename packages due to Soname change
  * Make libopencv-java unversioned
  * Drop old manpages
  * Bump policy version (no changes)
  * Use dh-sequences
  * Remove old files in d/

 -- Jochen Sprickerhof <jspricke@debian.org>  Fri, 24 Jun 2022 10:06:16 +0200
